using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;

namespace ChartLabelsCustom
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.SuspendLayout();
			// 
			// chartControl1
			// 
			this.chartControl1.Location = new System.Drawing.Point(8, 8);
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.Orientation = System.Windows.Forms.Orientation.Horizontal;
			this.chartControl1.Size = new System.Drawing.Size(576, 224);
			this.chartControl1.TabIndex = 0;
			this.chartControl1.Text = "chartControl1";
			this.chartControl1.Click += new System.EventHandler(this.chartControl1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 238);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.chartControl1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		InitializeChartData();
		}

		/// <summary>
		/// Initializes the ChartControl's data and sets the Chart type
		/// </summary>
		protected void InitializeChartData()
		{
			Random random = new Random();
			
			ChartSeries series = this.chartControl1.Model.NewSeries("Tasks");
			series.Name = "Tasks";
			series.Text = series.Name;
			for(int j = 0; j < 10; j++)
			{
				series.Points.Add(j + 1, new DateTime[]{DateTime.Now.AddDays(random.Next(200)),DateTime.Now.AddDays( 200 + random.Next(400))});
			}
			series.Type = ChartSeriesType.Gantt;	
			this.chartControl1.Series.Add(series);

			this.chartControl1.PrimaryXAxis.ValueType = ChartValueType.DateTime;
			this.chartControl1.PrimaryXAxis.LabelIntersectAction = ChartLabelIntersectAction.MultipleRows;

			this.chartControl1.Text = "";
			this.chartControl1.Legend.Visible = false;

			// Y Axis labels
			this.chartControl1.ChartFormatAxisLabel += new ChartFormatAxisLabelEventHandler(this.chartControl1_ChartFormatAxisLabelEventHandler);
			this.chartControl1.PrimaryYAxis.LabelIntersectAction = ChartLabelIntersectAction.Rotate;

		}

		private void chartControl1_ChartFormatAxisLabelEventHandler(object sender,ChartFormatAxisLabelEventArgs args )
		{
			if(args.IsAxisPrimary && args.AxisOrientation == Orientation.Vertical)
			{
				if(args.Value >= 0 && args.Value < 10)
					args.Label = "Task " + (args.Value+1).ToString();
				else 
					args.Label = "";

				args.Handled = true;
			}
		}

		private void chartControl1_Click(object sender, System.EventArgs e)
		{
		
		}
	}
}
